# OpalLineMediaStream Class Reference

`#include <lidep.h>`

Inheritance diagram for OpalLineMediaStream:

List of all members.

## Public Member Functions

Overrides of OpalMediaStream class
virtual PBoolean | Open ()
virtual PBoolean | Close ()
virtual PBoolean | ReadPacket (RTP_DataFrame &packet)
virtual PBoolean | WritePacket (RTP_DataFrame &packet)
virtual PBoolean | ReadData (BYTE *data, PINDEX size, PINDEX &length)
virtual PBoolean | WriteData (const BYTE *data, PINDEX length, PINDEX &written)
virtual PBoolean | SetDataSize (PINDEX dataSize)
virtual PBoolean | IsSynchronous () const
virtual PBoolean | RequiresPatchThread (OpalMediaStream *sinkStream) const
Member variable access
OpalLine & | GetLine ()

## Protected Attributes

OpalLine & | line
bool | notUsingRTP
bool | useDeblocking
unsigned | missedCount
BYTE | lastSID [4]
bool | lastFrameWasSignal
unsigned | directLineNumber

## Detailed Description

This class describes a media stream that transfers data to/from a Line Interface Device.

## Constructor & Destructor Documentation

OpalLineMediaStream::OpalLineMediaStream | ( | OpalLineConnection & | conn,
|  | const OpalMediaFormat & | mediaFormat,
|  | unsigned | sessionID,
|  | PBoolean | isSource,
|  | OpalLine & | line |
| ) |  |  |

Construct a new media stream for Line Interface Devices.

Parameters:

  mediaFormat | Media format for stream
  sessionID | Session number for stream
  isSource | Is a source stream
  line | LID line to stream to/from

OpalLineMediaStream::OpalLineMediaStream | ( | OpalLineConnection & | conn,
|  | const OpalMediaFormat & | mediaFormat,
|  | unsigned | sessionID,
|  | PBoolean | isSource,
|  | OpalLine & | line |
| ) |  |  |

Construct a new media stream for Line Interface Devices.

Parameters:

  mediaFormat | Media format for stream
  sessionID | Session number for stream
  isSource | Is a source stream
  line | LID line to stream to/from

## Member Function Documentation

virtual PBoolean OpalLineMediaStream::Open | ( |  | ) | `[virtual]`

Open the media stream.

The default behaviour sets the OpalLineInterfaceDevice format and calls Resume() on the associated OpalMediaPatch thread.

Reimplemented from OpalMediaStream.

virtual PBoolean OpalLineMediaStream::Close | ( |  | ) | `[virtual]`

Close the media stream.

The default does nothing.

Reimplemented from OpalMediaStream.

virtual PBoolean OpalLineMediaStream::ReadPacket | ( | RTP_DataFrame & | packet | ) | `[virtual]`

Read an RTP frame of data from the source media stream. The default behaviour simply calls ReadData() on the data portion of the RTP_DataFrame and sets the frames timestamp and marker from the internal member variables of the media stream class.

Reimplemented from OpalMediaStream.

virtual PBoolean OpalLineMediaStream::WritePacket | ( | RTP_DataFrame & | packet | ) | `[virtual]`

Write an RTP frame of data to the sink media stream. The default behaviour simply calls WriteData() on the data portion of the RTP_DataFrame and and sets the internal timestamp and marker from the member variables of the media stream class.

Reimplemented from OpalMediaStream.

virtual PBoolean OpalLineMediaStream::ReadData | ( | BYTE * | data,
|  | PINDEX | size,
|  | PINDEX & | length |
| ) |  |  | `[virtual]`

Read raw media data from the source media stream. The default behaviour reads from the OpalLine object.

Parameters:

  data | Data buffer to read to
  size | Size of buffer
  length | Length of data actually read

Reimplemented from OpalMediaStream.

virtual PBoolean OpalLineMediaStream::WriteData | ( | const BYTE * | data,
|  | PINDEX | length,
|  | PINDEX & | written |
| ) |  |  | `[virtual]`

Write raw media data to the sink media stream. The default behaviour writes to the OpalLine object.

Parameters:

  data | Data to write
  length | Length of data to read.
  written | Length of data actually written

Reimplemented from OpalMediaStream.

virtual PBoolean OpalLineMediaStream::SetDataSize | ( | PINDEX | dataSize | ) | `[virtual]`

Set the data size in bytes that is expected to be used. Some media streams can make use of this information to perform optimisations.

The default behaviour does nothing.

Parameters:

  dataSize | New data size

Reimplemented from OpalMediaStream.

virtual PBoolean OpalLineMediaStream::IsSynchronous | ( |  | ) | const`[virtual]`

Indicate if the media stream is synchronous. Returns PTrue for LID streams.

Implements OpalMediaStream.

virtual PBoolean OpalLineMediaStream::RequiresPatchThread | ( | OpalMediaStream * | sinkStream | ) | const`[virtual]`

Indicate if the media stream requires a OpalMediaPatch thread (active patch). This is called on the source stream and is passed the sink stream that the patch will initially be using. The function could conditionally require the patch thread to execute a thread reading and writing data, or prevent it from doing so as it can do so in hardware in some way, e.g. if both streams where on the same OpalLineInterfaceDevice.

The default behaviour simply returns true.

Parameters:

  sinkStream | Sink stream for this source

Reimplemented from OpalMediaStream.

OpalLine& OpalLineMediaStream::GetLine | ( |  | ) | `[inline]`

Get the line being used by this media stream.

## Member Data Documentation

OpalLine& OpalLineMediaStream::line `[protected]`

bool OpalLineMediaStream::notUsingRTP `[protected]`

bool OpalLineMediaStream::useDeblocking `[protected]`

unsigned OpalLineMediaStream::missedCount `[protected]`

BYTE OpalLineMediaStream::lastSID[4]`[protected]`

bool OpalLineMediaStream::lastFrameWasSignal `[protected]`

unsigned OpalLineMediaStream::directLineNumber `[protected]`

The documentation for this class was generated from the following file:

- lidep.h